inlets = 1; 
outlets = 1; 

function export(dict, filepath) {
  //open a new file
  
  f = new File(filepath,"write","TEXT");
  
  f.open();
  
  if (f.isopen != true) {
    post("dict2reaper couldn't open a file to write\n");
    return;
  }

  sortedpertrack = new Dict();
  
  d = new Dict(dict);
  var keys = d.getkeys();
  if(typeof(keys) == "string") {keys = [keys];}//if one make array
  
  //sort the input dict per track
  var str = d.stringify();
  var json = JSON.parse(str);
  for (var i = 0; i < keys.length; i++) {
    sortedpertrack.append(json[keys[i]]["track"]+"::"+keys[i]+"::file", json[keys[i]]["file"]) 
    sortedpertrack.append(json[keys[i]]["track"]+"::"+keys[i]+"::offset", json[keys[i]]["offset"]) 
    sortedpertrack.append(json[keys[i]]["track"]+"::"+keys[i]+"::start", json[keys[i]]["start"]) 
    sortedpertrack.append(json[keys[i]]["track"]+"::"+keys[i]+"::length", json[keys[i]]["length"]) 
  }
  
  //write the header
  f.writeline("<REAPER_PROJECT 0.1 \"5.99/OSX64\" 1603037150\n");

  //iter throught the tracks
  var trackeys = sortedpertrack.getkeys();
  if(typeof(trackeys) == "string") {trackeys = [trackeys];}//if one make array
  // post(trackeys +'\n');  
  for (var i = 0; i < trackeys.length; i++) {
    //write the track header
    f.writeline("<TRACK\nNAME \"" + trackeys[i] + "\"");
    // iter throught the items of that track
    items = sortedpertrack.get(trackeys[i]);
    var itemkeys = items.getkeys();
    if(typeof(itemkeys) == "string") {itemkeys = [itemkeys];}//if one make array
    // post(itemkeys +'\n');
    var stritem = items.stringify();
    var jsonitem = JSON.parse(stritem);
    for (var j = 0; j < itemkeys.length; j++) {
      //write the item
      f.writeline("<ITEM\nPOSITION " + jsonitem[itemkeys[j]]["start"]  / 1000.0 + "\nLENGTH " + jsonitem[itemkeys[j]]["length"] / 1000.0 + "\nNAME \"" + itemkeys[j] + "\"\nSOFFS " + jsonitem[itemkeys[j]]["offset"]  / 1000.0 + "\n<SOURCE WAVE\nFILE \"" + jsonitem[itemkeys[j]]["file"] + "\"\n>\n>");     
    }
    //write the track footer
    f.writeline(">");
  }
  
  //write the footer
  f.writeline(">");
  f.close();
}
